package Demo4;

import java.util.ArrayList;
import java.util.Arrays;

public class Principal {
	public static < N extends Nombre< N > > Nombre< N > somme( ArrayList< N > tableau ){
		Nombre< N > resultat = null;
		int i = 0;

		if( ! tableau.isEmpty() ) {
			resultat = tableau.get(0);
			
			for( i = 1; i < tableau.size(); ++ i ){
				resultat = resultat.add( tableau.get( i ) );
			}
		}
		
		return resultat;
	}

	public static void main( String [] args ){
		ArrayList< NDouble > a1 = new ArrayList<>( Arrays.asList( new NDouble(2.7), new NDouble(3.1), new NDouble(4.6) ) );
		
		System.out.println( somme( a1 ) );
		
		ArrayList< Fraction > a2 = new ArrayList<>( Arrays.asList( new Fraction( 1, 2 ), new Fraction( 1, 4 ), new Fraction( 2, 8 ) ) );
		
		System.out.println( somme( a2 ) );
	}
}
